﻿Public Class Form1

    Private Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Integer)

    Dim checkboxAi(0 To 23) As CheckBox
    Dim textboxAiValue(0 To 23) As TextBox
    Dim checkboxDi(0 To 3) As CheckBox
    Dim checkboxDo(0 To 3) As CheckBox

    Dim DevIndex As Integer
    Dim bRun As Boolean
    Dim Model(4) As Byte


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim temp As Integer
        Dim i As Integer

        temp = FindUSB3DAQ()
        If (temp > 0) Then

            For i = 0 To temp - 1
                comboboxDeviceIndex.Items.Add(i)
            Next

            comboboxDeviceIndex.SelectedIndex = 0
            btnStart.Enabled = True
        Else
            btnStart.Enabled = False
        End If

        For i = 0 To 23
            checkboxAi(i) = New CheckBox
            checkboxAi(i).Width = 60
            checkboxAi(i).Text = "Ai " & i.ToString
            checkboxAi(i).Left = 20 + 75 * (i \ 8)
            checkboxAi(i).Top = 20 + (i Mod 8) * 20
            GroupBox1.Controls.Add(checkboxAi(i))

            textboxAiValue(i) = New TextBox
            textboxAiValue(i).Width = 50
            textboxAiValue(i).Left = 20 + 55 * (i Mod 8)
            textboxAiValue(i).Top = 20 + (i \ 8) * 60
            GroupBox2.Controls.Add(textboxAiValue(i))
        Next

        For i = 0 To 7
            checkboxAi(i).Checked = True
        Next

        textboxAO_0.Text = 0
        textboxAO_1.Text = 0
        textboxAO_2.Text = 0
        textboxAO_3.Text = 0

        For i = 0 To 3
            checkboxDi(i) = New CheckBox
            checkboxDi(i).Text = "Di " & i.ToString
            checkboxDi(i).Left = 54
            checkboxDi(i).Top = 20 + 22 * i
            GroupBox4.Controls.Add(checkboxDi(i))
        Next

        For i = 0 To 3
            checkboxDo(i) = New CheckBox
            checkboxDo(i).Text = "Do " & i.ToString
            checkboxDo(i).Left = 54
            checkboxDo(i).Top = 20 + 22 * i
            GroupBox5.Controls.Add(checkboxDo(i))
        Next

        btnStop.Enabled = False
        bRun = False

    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click

        Dim i As Integer
        Dim j As Integer
        Dim temp As Integer
        Dim SN(8) As Byte

        '获取设备索引号
        DevIndex = comboboxDeviceIndex.SelectedIndex

        '打开指定索引号的设备
        temp = USB3OpenDevice(DevIndex)

        '显示设备序列号
        temp = USB3GetDeviceSN(DevIndex, SN(0))
        textboxSN.Text = "SN: " + System.Text.Encoding.ASCII.GetString(SN)

        temp = USB3GetDeviceModel(DevIndex, Model(0))
        textboxModel.Text = "Model: " + System.Text.Encoding.ASCII.GetString(Model)

        If Model(1) = &H31 Or Model(1) = &H32 Then
            '如果型号为31xx，32xx，才有Ai功能

            '-----------------------------------------
            'Ai 相关的设置

            '对 24 个通道进行配置
            For i = 0 To 23
                '选择是否要启用该通道
                temp = SetUSB3AiChanSel(DevIndex, i, CByte(checkboxAi(i).CheckState))
                '设置该通道的量程
                temp = SetUSB3AiRange(DevIndex, i, 10.24)

                '清空所有的 Ai 显示
                textboxAiValue(i).Text = ""
            Next

            '设置采集模式为 OneShot 模式
            temp = SetUSB3AiSampleMode(DevIndex, 1)

            '设置OneShot模式时，每通道采集 200 点
            temp = SetUSB3AiOneShotPoints(DevIndex, 200)

            '设置 Ai 输入的接线方式为 NRSE
            temp = SetUSB3AiConnectType(DevIndex, 1)

            '设置 Ai 输入的采样周期为 10000 ns，即 10us，采样率为 100kHz
            temp = SetUSB3AiSampleRate(DevIndex, 10000)

            '设置 Ai 触发源为软件触发
            temp = SetUSB3AiTrigSource(DevIndex, 0)

            '设置 Ai 采样时钟为 Ai 内部采样时钟
            temp = SetUSB3AiConvSource(DevIndex, 0)

            '设置 Ai 预触发点数为 0
            temp = SetUSB3AiPreTrigPoints(DevIndex, 0)

            '清空一次 AiFifo
            temp = SetUSB3ClrAiFifo(DevIndex)

        End If

        If Model(1) = &H31 Or Model(1) = &H32 Then
            '如果型号为31xx，32xx，才有Di功能

            '----------------------------------------------
            'Di 相关的设置

            '设置采集模式为 OneShot 模式
            temp = SetUSB3DiSampleMode(DevIndex, 1)

            '设置OneShot模式时，每通道采集 1 点
            temp = SetUSB3DiOneShotPoints(DevIndex, 1)

            '设置 Di 输入的采样周期为 10000 ns，即 10us，采样率为 100kHz
            temp = SetUSB3DiSampleRate(DevIndex, 10000)

            '设置 Di 触发源为软件触发
            temp = SetUSB3DiTrigSource(DevIndex, 0)

            '设置 Di 采样时钟为 Di 内部采样时钟
            temp = SetUSB3DiConvSource(DevIndex, 0)

            '设置 Di 预触发点数为 0
            temp = SetUSB3DiPreTrigPoints(DevIndex, 0)

            '清空一次 DiFifo
            temp = SetUSB3ClrDiFifo(DevIndex)

        End If

        '启动 Timer1
        Timer1.Enabled = True
        btnStart.Enabled = False
        btnStop.Enabled = True
        bRun = True

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim i As Integer
        Dim j As Integer
        Dim temp As Integer
        Static Dim ai(4800000) As Single
        Dim di(100) As Byte
        Dim average As Single

        If Model(1) = &H31 Or Model(1) = &H32 Then
            '如果型号为31xx，32xx，才有Ai功能

            '------------------------------------------------
            'Analog Input 相关的功能

            '启动一次软件触发
            temp = SetUSB3AiSoftTrig(DevIndex)
            Sleep(10)
            '每个通道读出 200 个数，存放在 ai 数组中
            temp = USB3GetAi(DevIndex, 200, ai(0), 1000)

            temp = 0
            '计算本次采集一共选择了多少个通道
            For i = 0 To 23
                temp = temp + CByte(checkboxAi(i).CheckState)
            Next

            '计算各个通道测量电压的平均值，并显示
            For j = 0 To temp - 1
                average = 0
                For i = 0 To 199
                    average = average + ai(j * 200 + i)
                Next
                average = average / 200
                textboxAiValue(j).Text = Format(average, "0.0000")
            Next

            '清除硬件触发标志
            temp = SetUSB3ClrAiTrigger(DevIndex)
            '清空 Ai Fifo
            temp = SetUSB3ClrAiFifo(DevIndex)

        End If

        If Model(1) = &H31 Or Model(1) = &H35 Then
            '如果型号为31xx，35xx，才有Ao功能

            '---------------------------------------------
            'Analong Ouput 相关的功能

            If Val(textboxAO_0.Text) < -10 Or Val(textboxAO_0.Text) > 10 Then
                textboxAO_0.Text = 0
            End If
            '设置 AO 0 电压
            temp = SetUSB3AoImmediately(DevIndex, 0, CSng(Val(textboxAO_0.Text)))

            If Val(textboxAO_1.Text) < -10 Or Val(textboxAO_1.Text) > 10 Then
                textboxAO_1.Text = 0
            End If
            '设置 AO 1 电压
            temp = SetUSB3AoImmediately(DevIndex, 1, CSng(Val(textboxAO_1.Text)))

            If Val(textboxAO_2.Text) < -10 Or Val(textboxAO_2.Text) > 10 Then
                textboxAO_2.Text = 0
            End If
            '设置 AO 2 电压
            temp = SetUSB3AoImmediately(DevIndex, 2, CSng(Val(textboxAO_2.Text)))

            If Val(textboxAO_3.Text) < -10 Or Val(textboxAO_3.Text) > 10 Then
                textboxAO_3.Text = 0
            End If
            '设置 AO 3 电压
            temp = SetUSB3AoImmediately(DevIndex, 3, CSng(Val(textboxAO_3.Text)))

        End If

        If Model(1) = &H31 Or Model(1) = &H32 Then
            '如果型号为31xx，32xx，才有DiDo功能

            '----------------------------------------------------
            'Digital Input 相关的功能

            '启动一次软件触发
            temp = SetUSB3DiSoftTrig(DevIndex)

            '读取 Di 状态，存放于 di数组中
            temp = USB3GetDi(DevIndex, 1, di(0), 100)

            '显示 Di 状态
            'di 低四位对应四个 Di 通道
            For i = 0 To 3
                checkboxDi(i).CheckState = di(0) And &H1
                di(0) = di(0) \ 2
            Next

            '清除硬件触发标志
            temp = SetUSB3ClrDiTrigger(DevIndex)

            '清空 Di Fifo
            temp = SetUSB3ClrDiFifo(DevIndex)


            '----------------------------------------------------
            'Digital Output 相关的功能

            For i = 0 To 3
                '设置 Do 输出状态
                temp = SetUSB3DoImmediately(DevIndex, i, checkboxDo(i).CheckState)
            Next

        End If

    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click

        CloseDevice

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing

        If bRun = True Then
            CloseDevice
        End If

    End Sub

    Private Sub CloseDevice()

        Dim temp As Integer

        Timer1.Enabled = False
        Sleep(200)

        '关闭设备
        temp = USB3CloseDevice(DevIndex)

        btnStart.Enabled = True
        btnStop.Enabled = False
        bRun = False

    End Sub
End Class
