﻿Module USB3000

    Public Declare Function FindUSB3DAQ Lib "USB3000.dll" () As Integer
    Public Declare Function USB3OpenDevice Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function USB3CloseDevice Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function USB3GetDeviceSN Lib "USB3000.dll" (ByVal DevIndex As Integer, ByRef SN As Byte) As Integer
    Public Declare Function USB3GetDeviceModel Lib "USB3000.dll" (ByVal DevIndex As Integer, ByRef Model As Byte) As Integer

    '-------------------------------------------------------------------------------------------------------------------------------------------
    'Ananlog Input Configuration

    Public Declare Function SetUSB3AiSampleRate Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal SamplePeriod As UInteger) As Integer
    Public Declare Function SetUSB3AiSampleMode Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal AiSampleMode As Byte) As Integer
    Public Declare Function SetUSB3AiConnectType Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal AiConnectType As Byte) As Integer
    Public Declare Function SetUSB3AiRange Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByVal AiRange As Single) As Integer
    Public Declare Function SetUSB3AiChanSel Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByVal Sel As Byte) As Integer
    Public Declare Function SetUSB3AiTrigSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal AiTrigSource As Byte) As Integer
    Public Declare Function SetUSB3AiConvSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal AiConvSource As Byte) As Integer
    Public Declare Function SetUSB3AiPreTrigPoints Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal AiPreTrigPoints As UInteger) As Integer
    Public Declare Function SetUSB3AiOneShotPoints Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal AiOneShotPoints As UInteger) As Integer
    Public Declare Function SetUSB3ClrAiFifo Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer

    '-------------------------------------------------------------------------------------------------------------------------------------------
    'Digital I/O Configuration

    Public Declare Function SetUSB3DiSampleRate Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal SamplePeriod As UInteger) As Integer
    Public Declare Function SetUSB3DiSampleMode Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DiSampleMode As Byte) As Integer
    Public Declare Function SetUSB3DiTrigSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DiTrigSource As Byte) As Integer
    Public Declare Function SetUSB3DiConvSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DiConvSource As Byte) As Integer
    Public Declare Function SetUSB3DiPreTrigPoints Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DiPreTrigPoints As UInteger) As Integer
    Public Declare Function SetUSB3DiOneShotPoints Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DiOneShotPoints As UInteger) As Integer
    Public Declare Function SetUSB3ClrDiFifo Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer

    Public Declare Function SetUSB3DoSampleRate Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal SamplePeriod As UInteger) As Integer
    Public Declare Function SetUSB3DoSampleMode Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DoSampleMode As Byte) As Integer
    Public Declare Function SetUSB3DoTrigSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DoTrigSource As Byte) As Integer
    Public Declare Function SetUSB3DoConvSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DoConvSource As Byte) As Integer
    Public Declare Function SetUSB3DoCycle Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal DoCycle As UInteger) As Integer
    Public Declare Function SetUSB3DoDataFifo Lib "USB3000.dll" (ByVal DevIndex As Integer, ByRef Value As UInteger, ByVal Len As UInteger) As Integer
    Public Declare Function SetUSB3ClrDoFifo Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function SetUSB3DoWaveCtrl Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As UInteger) As Integer
    Public Declare Function SetUSB3DoImmediately Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As UInteger, ByVal Value As UInteger) As Integer

    '-------------------------------------------------------------------------------------------------------------------------------------------
    'Ananlog Output Configuration

    Public Declare Function SetUSB3AoSampleRate Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByVal SamplePeriod As UInteger) As Integer
    Public Declare Function SetUSB3AoSampleMode Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByVal AoSampleMode As Byte) As Integer
    Public Declare Function SetUSB3AoTrigSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByVal AoTrigSource As Byte) As Integer
    Public Declare Function SetUSB3AoConvSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByVal AoConvSource As Byte) As Integer
    Public Declare Function SetUSB3AoCycle Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByVal AoCycle As UInteger) As Integer
    Public Declare Function SetUSB3AoDataFifo Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByRef Voltage As Single, ByVal Len As UInteger) As Integer
    Public Declare Function SetUSB3ClrAoFifo Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte) As Integer
    Public Declare Function SetUSB3AoSync Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chans As Byte) As Integer
    Public Declare Function SetUSB3AoImmediately Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte, ByVal Voltage As Single) As Integer

    '-------------------------------------------------------------------------------------------------------------------------------------------
    'Trig Control

    Public Declare Function SetUSB3AiSoftTrig Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function SetUSB3DiSoftTrig Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function SetUSB3DoSoftTrig Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function SetUSB3AoSoftTrig Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte) As Integer
    Public Declare Function SetUSB3GlobalSoftTrig Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer

    Public Declare Function SetUSB3ClrTrigger Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function SetUSB3ClrAiTrigger Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function SetUSB3ClrDiTrigger Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function SetUSB3ClrDoTrigger Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer
    Public Declare Function SetUSB3ClrAoTrigger Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Chan As Byte) As Integer
    Public Declare Function SetUSB3ClrGlobalSoftTrig Lib "USB3000.dll" (ByVal DevIndex As Integer) As Integer

    '-------------------------------------------------------------------------------------------------------------------------------------------
    'Sync Configuration

    Public Declare Function SetUSB3ExtTrigOutSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Source As Byte) As Integer
    Public Declare Function SetUSB3ExtConvOutSource Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Source As Byte) As Integer

    '-------------------------------------------------------------------------------------------------------------------------------------------
    'Get Data Acquired

    Public Declare Function USB3GetAi Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Points As UInteger, ByRef Ai As Single, ByVal TimeOut As Integer) As Integer
    Public Declare Function USB3GetDi Lib "USB3000.dll" (ByVal DevIndex As Integer, ByVal Points As UInteger, ByRef Di As Byte, ByVal TimeOut As Integer) As Integer

End Module
