﻿Public Class Form1

    Private Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Integer)

    Dim checkboxAi(0 To 23) As CheckBox
    Dim textboxAiValue(0 To 23) As TextBox
    Dim checkboxDi(0 To 3) As CheckBox
    Dim checkboxDo(0 To 3) As CheckBox

    Dim DevIndex As Integer
    Dim bRun As Boolean


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim temp As Integer
        Dim i As Integer

        temp = FindUSB3DAQ()
        If (temp > 0) Then

            For i = 0 To temp - 1
                comboboxDeviceIndex.Items.Add(i)
            Next

            comboboxDeviceIndex.SelectedIndex = 0
            btnStart.Enabled = True
        Else
            btnStart.Enabled = False
        End If

        For i = 0 To 3
            checkboxDi(i) = New CheckBox
            checkboxDi(i).Text = "Di " + i.ToString
            checkboxDi(i).Top = 40
            checkboxDi(i).Left = 100 + i * 150
            GroupBox1.Controls.Add(checkboxDi(i))
        Next

        btnStop.Enabled = False
        bRun = False

    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click

        Dim i As Integer
        Dim j As Integer
        Dim temp As Integer
        Dim SN(8) As Byte

        '获取设备索引号
        DevIndex = comboboxDeviceIndex.SelectedIndex

        '打开指定索引号的设备
        temp = USB3OpenDevice(DevIndex)

        '显示设备序列号
        temp = USB3GetDeviceSN(DevIndex, SN(0))
        textboxSN.Text = "SN: " + System.Text.Encoding.ASCII.GetString(SN)

        '-----------------------------------------
        'Di 相关的设置

        '设置采集模式为 连续采集 模式
        temp = SetUSB3DiSampleMode(DevIndex, 0)

        '设置 Di 输入的采样周期为 10000 ns，即 10us，采样率为 100kHz
        temp = SetUSB3DiSampleRate(DevIndex, 10000)

        '设置 Di 触发源为软件触发
        temp = SetUSB3DiTrigSource(DevIndex, 0)

        '设置 Di 采样时钟为 Di 内部采样时钟
        temp = SetUSB3DiConvSource(DevIndex, 0)

        '设置 Di 预触发点数为 0
        temp = SetUSB3DiPreTrigPoints(DevIndex, 0)

        '清空一次 AiFifo
        temp = SetUSB3ClrDiFifo(DevIndex)

        '启动一次软件触发
        temp = SetUSB3DiSoftTrig(DevIndex)


        '启动 Timer1
        Timer1.Interval = 5
        Timer1.Enabled = True
        btnStart.Enabled = False
        btnStop.Enabled = True
        bRun = True

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim i As Integer
        Dim j As Integer
        Dim temp As Integer
        Dim di(5000) As Byte
        Dim average As Single

        '------------------------------------------------
        'Digital Input 相关的功能

        '从 DiFifo 中每个通道读出 1000 个数，存放在 ai 数组中
        '每次读出来的数据连在一起，将是连续无间断采集得到的一组数据
        temp = USB3GetDi(DevIndex, 5000, di(0), 1000)

        '显示 DiFifo 中还有多少个数据点没被读出来
        '在长时间连续无间断采集的应用中，需注意 temp 数值的变化
        '如果 temp 值在逐渐增大，说明数据处理速度不够快，导致了数据积压在 DiFifo 中
        textboxFifoNum.Text = temp

        '显示 Di 连续数据中最新一个状态
        'di 低四位对应四个 Di 通道
        For i = 0 To 3
            checkboxDi(i).CheckState = di(4999) And &H1
            di(4999) = di(4999) \ 2
        Next

    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click

        CloseDevice

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing

        If bRun = True Then
            CloseDevice
        End If

    End Sub

    Private Sub CloseDevice()

        Dim temp As Integer

        Timer1.Enabled = False
        Sleep(100)

        '清除硬件触发标志
        temp = SetUSB3ClrDiTrigger(DevIndex)
        '清空 Ai Fifo
        temp = SetUSB3ClrDiFifo(DevIndex)

        '关闭设备
        temp = USB3CloseDevice(DevIndex)

        btnStart.Enabled = True
        btnStop.Enabled = False
        bRun = False

    End Sub
End Class
