﻿Public Class Form1

    Private Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Integer)

    Dim checkboxAi(0 To 23) As CheckBox
    Dim textboxAiValue(0 To 23) As TextBox
    Dim checkboxDi(0 To 3) As CheckBox
    Dim checkboxDo(0 To 3) As CheckBox

    Dim DevIndex As Integer
    Dim bRun As Boolean


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim temp As Integer
        Dim i As Integer

        temp = FindUSB3DAQ()
        If (temp > 0) Then

            For i = 0 To temp - 1
                comboboxDeviceIndex.Items.Add(i)
            Next

            comboboxDeviceIndex.SelectedIndex = 0
            btnStart.Enabled = True
        Else
            btnStart.Enabled = False
        End If

    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click

        Dim i As Integer
        Dim j As Integer
        Dim temp As Integer
        Dim SN(8) As Byte
        Dim WaveData(100) As Single

        '获取设备索引号
        DevIndex = comboboxDeviceIndex.SelectedIndex

        '打开指定索引号的设备
        temp = USB3OpenDevice(DevIndex)

        '显示设备序列号
        temp = USB3GetDeviceSN(DevIndex, SN(0))
        textboxSN.Text = "SN: " + System.Text.Encoding.ASCII.GetString(SN)

        '-----------------------------------------
        'Ao Wave 相关的设置

        '清除 Ao_0 的触发标志
        temp = SetUSB3ClrAoTrigger(DevIndex, 0)

        '清空 Ao_0 的硬件 Fifo 空间
        temp = SetUSB3ClrAoFifo(DevIndex, 0)

        '设置 Ao_0 输出模式为 硬件 Fifo 缓冲的波形输出
        temp = SetUSB3AoSampleMode(DevIndex, 0, 1)

        '设置 Ao_0 输入的采样周期为 10000 ns，即 10us，采样率为 100kHz
        temp = SetUSB3AoSampleRate(DevIndex, 0, 1000)

        '设置 Ao_0 触发源为软件触发
        temp = SetUSB3AoTrigSource(DevIndex, 0, 0)

        '设置 Ao_0 采样时钟为内部 Ao 采样时钟
        temp = SetUSB3AoConvSource(DevIndex, 0, 0)

        '设置 Ao_0 输出波形 Cycle 数量为 0，表示无限循环输出
        '如果 Cycle 数量设置为 1 ，那么波表数据完整输出一次即停
        temp = SetUSB3AoCycle(DevIndex, 0, 0)

        '产生一个由 100 个 0 ~ 1V 的随机数组成的波形，存放于 WaveData 中
        For i = 0 To 99
            WaveData(i) = Rnd()
        Next

        '将 100 个点长度的波形 WaveData 下载到硬件 Fifo 中
        temp = SetUSB3AoDataFifo(DevIndex, 0, WaveData(0), 100)

        '软件发出 Ao_0
        temp = SetUSB3AoSoftTrig(DevIndex, 0)

        '关闭设备
        temp = USB3CloseDevice(DevIndex)

    End Sub

End Class
