﻿Public Class Form1

    Private Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Integer)

    Dim checkboxAi(0 To 23) As CheckBox
    Dim textboxAiValue(0 To 23) As TextBox
    Dim checkboxDi(0 To 3) As CheckBox
    Dim checkboxDo(0 To 3) As CheckBox

    Dim DevIndex As Integer
    Dim bRun As Boolean


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim temp As Integer
        Dim i As Integer

        temp = FindUSB3DAQ()
        If (temp > 0) Then

            For i = 0 To temp - 1
                comboboxDeviceIndex.Items.Add(i)
            Next

            comboboxDeviceIndex.SelectedIndex = 0
            btnStart.Enabled = True
        Else
            btnStart.Enabled = False
        End If

    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click

        Dim i As Integer
        Dim j As Integer
        Dim temp As Integer
        Dim SN(8) As Byte
        Dim WaveData(100) As Single

        '获取设备索引号
        DevIndex = comboboxDeviceIndex.SelectedIndex

        '打开指定索引号的设备
        temp = USB3OpenDevice(DevIndex)

        '显示设备序列号
        temp = USB3GetDeviceSN(DevIndex, SN(0))
        textboxSN.Text = "SN: " + System.Text.Encoding.ASCII.GetString(SN)

        '-----------------------------------------
        'Ao Wave 相关的设置

        '清除全局软件触发标志
        temp = SetUSB3ClrGlobalSoftTrig(DevIndex)

        '分别清除 4 个 Ao 的触发标志
        For i = 0 To 3
            temp = SetUSB3ClrAoTrigger(DevIndex, i)
        Next


        '分别清空 4 个 Ao 的硬件 Fifo 空间
        For i = 0 To 3
            temp = SetUSB3ClrAoFifo(DevIndex, i)
        Next

        '分别设置 4 个 Ao 输出模式为 硬件 Fifo 缓冲的波形输出
        For i = 0 To 3
            temp = SetUSB3AoSampleMode(DevIndex, i, 1)
        Next

        '分别设置 4 个 Ao 输入的采样周期为 10000 ns，即 10us，采样率为 100kHz
        For i = 0 To 3
            temp = SetUSB3AoSampleRate(DevIndex, i, 1000)
        Next

        '分别设置 4 个 Ao 触发源为全局软件触发
        For i = 0 To 3
            temp = SetUSB3AoTrigSource(DevIndex, i, 255)
        Next

        '分别设置 4 个 Ao 采样时钟为内部 Ao 采样时钟
        For i = 0 To 3
            temp = SetUSB3AoConvSource(DevIndex, i, 0)
        Next

        '分别设置 4 个 Ao 输出波形 Cycle 数量为 0，表示无限循环输出
        '如果 Cycle 数量设置为 1 ，那么波表数据完整输出一次即停
        For i = 0 To 3
            temp = SetUSB3AoCycle(DevIndex, i, 0)
        Next

        '产生一个由 100 个 0 ~ 1V 的随机数组成的波形，存放于 WaveData 中
        For i = 0 To 99
            WaveData(i) = Rnd()
        Next

        '分别将 100 个点长度的波形 WaveData 下载到 4 个硬件 Ao Fifo 中
        For i = 0 To 3
            temp = SetUSB3AoDataFifo(DevIndex, i, WaveData(0), 100)
        Next

        '开启需要同步采样输出通道
        '&HF 的每一 bit 代表一个通道，&HF 表示 4 个通道全部开启同步采样输出
        temp = SetUSB3AoSync(DevIndex, &HF)

        '全局软件触发
        temp = SetUSB3GlobalSoftTrig(DevIndex)

        '关闭设备
        temp = USB3CloseDevice(DevIndex)

    End Sub

End Class
