﻿Public Class Form1

    Private Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Integer)

    Dim checkboxAi(0 To 23) As CheckBox
    Dim textboxAiValue(0 To 23) As TextBox
    Dim checkboxDi(0 To 3) As CheckBox
    Dim checkboxDo(0 To 3) As CheckBox

    Dim DevIndex As Integer
    Dim bRun As Boolean

    Dim WaveData(1000) As Single
    Dim Rounds As ULong
    Dim threadDownload As Threading.Thread


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim temp As Integer
        Dim i As Integer

        temp = FindUSB3DAQ()
        If (temp > 0) Then

            For i = 0 To temp - 1
                comboboxDeviceIndex.Items.Add(i)
            Next

            comboboxDeviceIndex.SelectedIndex = 0
            btnStart.Enabled = True
        Else
            btnStart.Enabled = False
        End If

        btnStop.Enabled = False

    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click

        Dim i As Integer
        Dim j As Integer
        Dim temp As Integer
        Dim SN(8) As Byte

        '产生一个由 1000 个 0 ~ 1V 的随机数组成的波形，存放于 WaveData 中
        For i = 0 To 999
            WaveData(i) = Rnd()
        Next

        '获取设备索引号
        DevIndex = comboboxDeviceIndex.SelectedIndex

        '打开指定索引号的设备
        temp = USB3OpenDevice(DevIndex)

        '显示设备序列号
        temp = USB3GetDeviceSN(DevIndex, SN(0))
        textboxSN.Text = System.Text.Encoding.ASCII.GetString(SN)

        '-----------------------------------------
        'Ao Wave 相关的设置

        '清除 Ao_0 的触发标志
        temp = SetUSB3ClrAoTrigger(DevIndex, 0)

        '清空 Ao_0 的硬件 Fifo 空间
        temp = SetUSB3ClrAoFifo(DevIndex, 0)

        '设置 Ao_0 输出模式为 计算机缓冲的无限长度不循环波形输出模式
        temp = SetUSB3AoSampleMode(DevIndex, 0, 0)

        '设置 Ao_0 输入的采样周期为 10000 ns，即 10us，采样率为 100kHz
        temp = SetUSB3AoSampleRate(DevIndex, 0, 1000)

        '设置 Ao_0 触发源为软件触发
        temp = SetUSB3AoTrigSource(DevIndex, 0, 0)

        '设置 Ao_0 采样时钟为内部 Ao 采样时钟
        temp = SetUSB3AoConvSource(DevIndex, 0, 0)

        '将 1000 个点长度的波形 WaveData 下载到硬件 Fifo 中
        temp = SetUSB3AoDataFifo(DevIndex, 0, WaveData(0), 1000)

        btnStart.Enabled = False
        btnStop.Enabled = True
        Rounds = 0
        bRun = True

        Timer1.Interval = 100
        Timer1.Enabled = True

        '软件触发 Ao_0
        temp = SetUSB3AoSoftTrig(DevIndex, 0)

        '创建一个线程用于源源不断的产生新的数据，并下载到采集卡硬件 Fifo 中
        threadDownload = New Threading.Thread(AddressOf DownloadWaveData)
        threadDownload.Start()

    End Sub

    Private Sub DownloadWaveData()

        Dim temp As Integer
        Dim i As Integer

        Do While bRun = True

            '更新波形数据
            For i = 0 To 999
                WaveData(i) = Rnd()
            Next

            '将更新后的 1000 个点长度的波形 WaveData 下载到硬件 Fifo 中
            temp = SetUSB3AoDataFifo(DevIndex, 0, WaveData(0), 1000)

            Rounds = Rounds + 1

            '因为 1000 点的数据能够输出 10ms，所以延时 5ms 之后再产生新的数据并下载，可以保证输出波形的无间断连续性
            Sleep(5)
        Loop

    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click

        CloseDevice()
        btnStart.Enabled = True
        btnStop.Enabled = False

    End Sub

    Private Sub CloseDevice()

        Dim temp As Integer

        If bRun = True Then
            bRun = False
            threadDownload.Join()

            '清除 Ao_0 触发标志
            temp = SetUSB3ClrAoTrigger(DevIndex, 0)

            '清空 Ao_0 硬件 Fifo
            temp = SetUSB3ClrAoFifo(DevIndex, 0)

            '关闭设备
            temp = USB3CloseDevice(DevIndex)
        End If

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing

        CloseDevice()

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        textboxRounds.Text = Rounds

    End Sub
End Class
